<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>Framework: ParrotNavBoard.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Framework
   </div>
   <div id="projectbrief">Framework drone</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_parrot_nav_board_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Properties</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ParrotNavBoard.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_parrot_nav_board_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef PARROTNAVBOARD_H</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#define PARROTNAVBOARD_H</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_thread_8h.html">Thread.h</a>&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">namespace </span>framework {</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    <span class="keyword">namespace </span>core {</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="keyword">class </span>FrameworkManager;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keyword">class </span>cvmatrix;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keyword">class </span>ImuData;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keyword">class </span>SerialPort;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    }</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;}</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">namespace </span>framework { <span class="keyword">namespace </span>sensor {</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keyword">class </span>Imu;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keyword">class </span>UsRangeFinder;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classframework_1_1sensor_1_1_parrot_nav_board.html">   31</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classframework_1_1sensor_1_1_parrot_nav_board.html">ParrotNavBoard</a> : <span class="keyword">public</span> <a class="code" href="classframework_1_1core_1_1_thread.html">core::Thread</a> {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keyword">public</span>:</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            <a class="code" href="classframework_1_1sensor_1_1_parrot_nav_board.html#ada58c857d32807cf6f15d3609cfc068c">ParrotNavBoard</a>(<span class="keyword">const</span> <a class="code" href="classframework_1_1core_1_1_framework_manager.html">core::FrameworkManager</a>* parent,std::string name,<a class="code" href="classframework_1_1core_1_1_serial_port.html">core::SerialPort</a>* serialport,uint8_t priority);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;            <a class="code" href="classframework_1_1sensor_1_1_parrot_nav_board.html#aead0fef1a9a6304ae48149fe12a161e2">~ParrotNavBoard</a>();</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            <span class="keywordtype">void</span> <a class="code" href="classframework_1_1sensor_1_1_parrot_nav_board.html#a77c5c95a5317b04c6d85ba5e6e774cc5">UseDefaultPlot</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            <a class="code" href="classframework_1_1sensor_1_1_imu.html">Imu</a>* <a class="code" href="classframework_1_1sensor_1_1_parrot_nav_board.html#a70dcdca8e5834c730875561ada54f250">GetImu</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            <a class="code" href="classframework_1_1sensor_1_1_us_range_finder.html">UsRangeFinder</a>* <a class="code" href="classframework_1_1sensor_1_1_parrot_nav_board.html#a3b1836df5bf813f241855bd76a6ff93f">GetUsRangeFinder</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keyword">private</span>:</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">struct </span>nav_struct</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            {</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;                uint16_t size;                <span class="comment">// +0x00 Size of the following data (always 0x3a)</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;                uint16_t seq;                 <span class="comment">// +0x02 Sequence number, increases every update</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;                uint16_t acc[3];              <span class="comment">// +0x04 Raw data (10-bit) of the accelerometers multiplied by 4</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;                int16_t gyro[3];             <span class="comment">// +0x0A Raw data for the gyros, 12-bit A/D converted voltage of the gyros. X,Y=IDG, Z=Epson</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;                uint16_t acc_temp;            <span class="comment">// +0x10 Accs temperature -- startup value 120 @ 25C, rising to 143</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;                uint16_t gyro_temp;           <span class="comment">// +0x12 XYGyro temperature (IDG), 12-bit A/D converted voltage of IDG&#39;s temperature sensor -- startup value 1532 @ 25C, rising to 1572</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;                uint16_t us_echo;             <span class="comment">// +0x14 bit15=1 echo pulse transmitted, bit14-0 first echo. Value 30 = 1cm. min value: 784 = 26cm</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;                uint16_t us_echo_start;       <span class="comment">// +0x16 Array with starts of echos (8 array values @ 25Hz, 9 values @ 22.22Hz)</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;                uint16_t us_echo_end;         <span class="comment">// +0x18 Array with ends of echos   (8 array values @ 25Hz, 9 values @ 22.22Hz)</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;                uint16_t us_association_echo; <span class="comment">// +0x1a Ultrasonic parameter -- echo number starting with 0. max value 3758. examples: 0,1,2,3,4,5,6,7  ; 0,1,2,3,4,86,6,9</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;                uint16_t us_distance_echo;    <span class="comment">// +0x1c Ultrasonic parameter -- no clear pattern</span></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                uint16_t us_courbe_temps;     <span class="comment">// +0x1e Ultrasonic parameter -- counts up from 0 to approx 24346 in 192 sample cycles of which 12 cylces have value 0</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;                uint16_t us_courbe_valeur;    <span class="comment">// +0x20 Ultrasonic parameter -- value between 0 and 4000, no clear pattern. 192 sample cycles of which 12 cylces have value 0</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;                uint16_t us_courbe_ref;       <span class="comment">// +0x22 Ultrasonic parameter -- coutns down from 4000 to 0 in 192 sample cycles of which 12 cylces have value 0</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;                uint16_t nb_echo;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;                uint32_t sum_echo;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;                int16_t gradient;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;                uint16_t flag_echo_ini;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;                int32_t pressure;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;                int16_t temprature_pressure;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;                int16_t mag[3];</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;                uint16_t checksum;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;            } __attribute__ ((packed)) nav_struct;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            <span class="keywordtype">void</span> Run(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            uint16_t Checksum(<span class="keyword">const</span> uint8_t *data) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;            <span class="keywordtype">void</span> computeDatas(nav_struct* nav,<a class="code" href="namespaceframework_1_1core.html#a556a09521d9b94e1c9f0bfe6744d611d">core::Time</a> time);</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            <a class="code" href="classframework_1_1sensor_1_1_imu.html">Imu</a>* imu;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            <a class="code" href="classframework_1_1sensor_1_1_us_range_finder.html">UsRangeFinder</a>* us;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            <a class="code" href="classframework_1_1core_1_1_serial_port.html">core::SerialPort</a>* serialport;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    };</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;} <span class="comment">// end namespace sensor</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;} <span class="comment">// end namespace framework</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="preprocessor">#endif // PARROTNAVBOARD_H</span></div>
<div class="ttc" id="classframework_1_1core_1_1_serial_port_html"><div class="ttname"><a href="classframework_1_1core_1_1_serial_port.html">framework::core::SerialPort</a></div><div class="ttdoc">Base class for serial port. </div><div class="ttdef"><b>Definition:</b> SerialPort.h:23</div></div>
<div class="ttc" id="classframework_1_1sensor_1_1_parrot_nav_board_html_a77c5c95a5317b04c6d85ba5e6e774cc5"><div class="ttname"><a href="classframework_1_1sensor_1_1_parrot_nav_board.html#a77c5c95a5317b04c6d85ba5e6e774cc5">framework::sensor::ParrotNavBoard::UseDefaultPlot</a></div><div class="ttdeci">void UseDefaultPlot(void)</div><div class="ttdoc">Use default plot. </div></div>
<div class="ttc" id="namespaceframework_1_1core_html_a556a09521d9b94e1c9f0bfe6744d611d"><div class="ttname"><a href="namespaceframework_1_1core.html#a556a09521d9b94e1c9f0bfe6744d611d">framework::core::Time</a></div><div class="ttdeci">unsigned long long Time</div><div class="ttdoc">Time definition, in ns. </div><div class="ttdef"><b>Definition:</b> Object.h:49</div></div>
<div class="ttc" id="classframework_1_1core_1_1_thread_html"><div class="ttname"><a href="classframework_1_1core_1_1_thread.html">framework::core::Thread</a></div><div class="ttdoc">Abstract class for a thread. </div><div class="ttdef"><b>Definition:</b> Thread.h:34</div></div>
<div class="ttc" id="classframework_1_1core_1_1_framework_manager_html"><div class="ttname"><a href="classframework_1_1core_1_1_framework_manager.html">framework::core::FrameworkManager</a></div><div class="ttdoc">Main class of the Framework library. </div><div class="ttdef"><b>Definition:</b> FrameworkManager.h:43</div></div>
<div class="ttc" id="classframework_1_1sensor_1_1_parrot_nav_board_html"><div class="ttname"><a href="classframework_1_1sensor_1_1_parrot_nav_board.html">framework::sensor::ParrotNavBoard</a></div><div class="ttdoc">Class for ArDrone 2 sensors. </div><div class="ttdef"><b>Definition:</b> ParrotNavBoard.h:31</div></div>
<div class="ttc" id="classframework_1_1sensor_1_1_us_range_finder_html"><div class="ttname"><a href="classframework_1_1sensor_1_1_us_range_finder.html">framework::sensor::UsRangeFinder</a></div><div class="ttdoc">Base class for UsRangeFinder. </div><div class="ttdef"><b>Definition:</b> UsRangeFinder.h:41</div></div>
<div class="ttc" id="_thread_8h_html"><div class="ttname"><a href="_thread_8h.html">Thread.h</a></div><div class="ttdoc">Abstract class for a thread. </div></div>
<div class="ttc" id="classframework_1_1sensor_1_1_parrot_nav_board_html_aead0fef1a9a6304ae48149fe12a161e2"><div class="ttname"><a href="classframework_1_1sensor_1_1_parrot_nav_board.html#aead0fef1a9a6304ae48149fe12a161e2">framework::sensor::ParrotNavBoard::~ParrotNavBoard</a></div><div class="ttdeci">~ParrotNavBoard()</div><div class="ttdoc">Destructor. </div></div>
<div class="ttc" id="classframework_1_1sensor_1_1_parrot_nav_board_html_a70dcdca8e5834c730875561ada54f250"><div class="ttname"><a href="classframework_1_1sensor_1_1_parrot_nav_board.html#a70dcdca8e5834c730875561ada54f250">framework::sensor::ParrotNavBoard::GetImu</a></div><div class="ttdeci">Imu * GetImu(void) const </div><div class="ttdoc">Get Imu. </div></div>
<div class="ttc" id="classframework_1_1sensor_1_1_parrot_nav_board_html_a3b1836df5bf813f241855bd76a6ff93f"><div class="ttname"><a href="classframework_1_1sensor_1_1_parrot_nav_board.html#a3b1836df5bf813f241855bd76a6ff93f">framework::sensor::ParrotNavBoard::GetUsRangeFinder</a></div><div class="ttdeci">UsRangeFinder * GetUsRangeFinder(void) const </div><div class="ttdoc">Get UsRangeFinder. </div></div>
<div class="ttc" id="classframework_1_1sensor_1_1_imu_html"><div class="ttname"><a href="classframework_1_1sensor_1_1_imu.html">framework::sensor::Imu</a></div><div class="ttdoc">Base class for Imu. </div><div class="ttdef"><b>Definition:</b> Imu.h:38</div></div>
<div class="ttc" id="classframework_1_1sensor_1_1_parrot_nav_board_html_ada58c857d32807cf6f15d3609cfc068c"><div class="ttname"><a href="classframework_1_1sensor_1_1_parrot_nav_board.html#ada58c857d32807cf6f15d3609cfc068c">framework::sensor::ParrotNavBoard::ParrotNavBoard</a></div><div class="ttdeci">ParrotNavBoard(const core::FrameworkManager *parent, std::string name, core::SerialPort *serialport, uint8_t priority)</div><div class="ttdoc">Constructor. </div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d9f696bd07998dbcfc5b49e19dc5f66d.html">igep</a></li><li class="navelem"><a class="el" href="dir_7775cfc2302e50905e8c794823e78d65.html">uav_lib</a></li><li class="navelem"><a class="el" href="dir_3d8b3ef72b6bddf04a7da37c46c6171b.html">framework</a></li><li class="navelem"><a class="el" href="dir_ebc679b331e9832181885980c13d7a0f.html">SensorActuator</a></li><li class="navelem"><a class="el" href="dir_a3adf9203c955b1977c072f893948685.html">src</a></li><li class="navelem"><a class="el" href="_parrot_nav_board_8h.html">ParrotNavBoard.h</a></li>
    <li class="footer">Generated on Tue Apr 12 2016 16:28:59 for Framework by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.7 </li>
  </ul>
</div>
</body>
</html>
